-- HTML output
-- public domain FA 1996-05

indexing
	description: "Eiffel output for HTML";
	comment: "this for inclusion in an existing HTML document and not a stand-alone page";
	licence: public_domain;
	interface: client, mixin;
	 
class EIFFEL_HTML inherit EIFFEL_PRINT end

creation make
	
feature
	
	print_prologue is
		do
			io.put_string("<pre>")
			io.put_new_line
		end

	print_epilogue is
		do
			io.put_string("</pre>")
			io.put_new_line
		end

feature	{ PUBLIC_NONE }
	
	print_character(c : CHARACTER) is
		do
			if c = '<' then
				io.put_string("&lt;")
			elseif c = '>' then
				io.put_string("&gt;")
			elseif c = '&' then
				io.put_string("&amp;")
			elseif c = '%T' then
				io.put_string("    ")
			else -- should do &#<number>; for > 128
				io.put_character(c)
			end
		end

	print_new_line is
		do
			-- io.put_string("<br>")
			io.put_new_line
		end

feature { PUBLIC_NONE }
	
	print_keyword(str : STRING) is
		do
			io.put_string("<b>")
			io.put_string(str)
			io.put_string("</b>")
		end

	print_identifier, print_number(str : STRING) is
		do
			io.put_string("<i>")
			io.put_string(str)
			io.put_string("</i>")
		end

	print_quoted_string(str : STRING) is
		do
			io.put_string("<i>")
			print_verbatim(str)
			io.put_string("</i>")
		end
	
	print_comment(str : STRING) is
		do
			print_verbatim(str) -- stay roman
		end
	
end -- class EIFFEL_HTML