-- Traf: a trivial Eiffel pretty printer
-- FA 1996-09
-- Public domain: may be copied, modified and sold freely

indexing
	cluster: traf
	description: "Eiffel pretty printer - command line driver"
	licence: public_domain
	version: 1996.09

class TRAF inherit ARGUMENTS

creation
	make

feature 

	Banner : STRING is "Traf, a simple free Eiffel pretty printer, version 1.0"
	Usage : STRING is "usage: traf (-html|-lout) [-version] [-help] [- <in >out]"

	make is
			-- Create.
		local
			i : INTEGER
			eiffel : EIFFEL_PRINT
			do_stdin : BOOLEAN
		do
			-- default
			!EIFFEL_HTML!eiffel.make
			
			-- argument
			from i := 1 variant argument_count + 1 - i until i > argument_count loop
				if argument(i).is_equal("-html") then
					!EIFFEL_HTML!eiffel.make
				elseif argument(i).is_equal("-lout") then
					!EIFFEL_LOUT!eiffel.make
				elseif argument(i).is_equal("-version") then
					io.put_string(Banner)
					io.put_new_line
				elseif argument(i).is_equal("-help") then
					io.put_string(Usage)
					io.put_new_line
				elseif argument(i).is_equal("-") then
					do_stdin := true
				else
					io.put_string("Invalid option.")
					io.put_new_line
					io.put_string(Usage)
					io.put_new_line
				end
				i := i + 1
			end

			if do_stdin then
								
				-- actual processing
				eiffel.print_prologue
				from until io.end_of_file loop -- end_of_file may not be portable
					io.read_line
					eiffel.print_eiffel_line(io.last_string)
				end
				eiffel.print_epilogue

			end
		end

end -- class TRAF